part of 'stylight.dart';

// Yes this is necessary
class LoadingIndicator extends StatelessWidget {

  @override
  Widget build(BuildContext context) {
    return Center(
      child: CircularProgressIndicator(),
    );
  }
}

class SettingsButton extends StatelessWidget {

  final String label;
  final bool bold;
  final Function() onPress;

  const SettingsButton({Key key, this.label, this.onPress, this.bold = false}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap: onPress,
      child: OutlineButton(
        onPressed: onPress,
        borderSide: BorderSide.none,
        child: TextStyles.Header.text(label, color: bold ? textColor1 : textColor2),
      ),
    );
  }
}


class SettingsView extends StatefulWidget {

  final int pages;
  final List<String> navigation;
  final Widget Function(BuildContext,int) builder;

  const SettingsView({Key key, this.pages, this.navigation, this.builder}) : super(key: key);



  @override
  _SettingsViewState createState() => _SettingsViewState(this);
}

class _SettingsViewState extends State<SettingsView> {

  final SettingsView parent;

  _SettingsViewState(this.parent);

  int selectedChild = 0;

  @override
  Widget build(BuildContext context) {
    List<SettingsButton> buttons = new List();
    for (int i = 0; i < parent.navigation.length; i++) {
      String item = parent.navigation[i];
      buttons.add(SettingsButton(label: item, bold: selectedChild == i));
    }

    return Row(
      crossAxisAlignment: CrossAxisAlignment.stretch,
      children: [
        Flexible(child: Container(
          color: primary[600],
          child: Column(
            children: [Container(height: 32,)]
              ..addAll(buttons),
          )
        ), flex: 1, fit: FlexFit.tight,),
        Flexible(
          child: parent.builder(context,selectedChild),
          flex: 4, fit: FlexFit.tight,
        ),
      ],
    );
  }
}
