import 'dart:convert';
// ignore: avoid_web_libraries_in_flutter
import 'dart:html' as html;
import 'dart:js' as js;

import 'package:flutter/material.dart';
import 'package:stylight/stylight.dart';

void download(String content, String file) {
  final bytes = utf8.encode(content);
  final blob = html.Blob([bytes]);
  final url = html.Url.createObjectUrlFromBlob(blob);
  final anchor = html.document.createElement('a') as html.AnchorElement
    ..href = url
    ..style.display = 'none'
    ..download = file;
  html.document.body.children.add(anchor);
  anchor.click();
  html.document.body.children.remove(anchor);
  html.Url.revokeObjectUrl(url);
}

void openLink(String href) {
  js.context.callMethod("open", [href]);
}

void snack(BuildContext context, Color color, String message) {
  final SnackBar snack = SnackBar(content: Padding(
    padding: const EdgeInsets.all(8.0),
    child: Text(message, style: TextStyle(color: Colors.white, fontSize: 18),),
  ), backgroundColor: color,);

  ScaffoldState state = context.findAncestorStateOfType<ScaffoldState>();
  state.showSnackBar(snack);
}

void success(BuildContext context, String message) {
  snack(context, Hues.Green.hard, message);
}

void info(BuildContext context, String message) {
  snack(context, Hues.Blue.hard, message);
}

void error(BuildContext context, String message) {
  snack(context, Hues.Red.hard, message);
}

void warning(BuildContext context, String message) {
  snack(context, Hues.Orange.hard, message);
}
